<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Session extends Controller_Handler {
        /** @var  User */
        protected $_user;   # $user is already defined in the parent class.
        
        public function before() {
            $this->_user = User::instance(true);
            parent::before();
            $this->setAccessLevel(self::ACCESS_ANYBODY);
        }

        public function action_getSessionTime() {
            $user = $this->_user;
            $session = Session::instance();
            
            if (!$user->isSignedIn()) {
                $remain = 0;
            } else {
                $start_time = $session->get('start_time');
                if (!isset($start_time)) {
                    $start_time =  time();
                }
                $interval = time() - $start_time;
                $config = Kohana::$config->load('session');
                $lifetime = $config["native"]["lifetime"];
                $remain = $lifetime - $interval; 
            }
            $this->response->body(json_encode($remain));
        }

        
        
        public function action_closeSession() {
            if (User::instance()->isSignedIn()) {
                User::instance()->signOut();
            }
            $this->response->body(json_encode(0));
        }
}